#include "backends/platform/android/button.h"

void Button::initTexture(){
			_texture= new GLES8888Texture();
			_texture->allocBuffer(_surface->w, _surface->h);
			debugdot("_surface->w=%d,_surface->h=%d,_surface->pixels=%d,_surface->pitch=%d",_surface->w,_surface->h,sizeof(_surface->pixels),_surface->pitch);
				updateBuffer();
			debugdot("ScaleX = %2.3f, Scale Y = %2.3f",scaleX,scaleY);
			
			//bound=Common::Rect(0-_bmpSurfaceOff.w/2,0-_bmpSurfaceOff.h/2,(_bmpSurfaceOff.w/2),(_bmpSurfaceOff.h/2));
			_staticGlobalBound=Common::Rect(centerX-(_surface->w/2)*scaleX,centerY-(_surface->h/2)*scaleY,centerX+(_surface->w/2)*scaleX,centerY+(_surface->h/2)*scaleY);
		debugdot("staticGlobalBound = left=%d,top=%d,right=%d,bottom=%d",_staticGlobalBound.left,_staticGlobalBound.top,_staticGlobalBound.right,_staticGlobalBound.bottom);
}


void Button::display() {
		_currentGlobalBound=_staticGlobalBound;
		_texture->setDrawRect(_currentGlobalBound);
		_texture->drawTextureRect();
}

void Button::release(){
	if(_texture)
		_texture->release();
	
}

void Button::reinit(){
	if(_texture)
		_texture->reinit();
}
