#include "backends/platform/android/dotemubmpfont.h"

char ** dotemuBmpFont::Split(const char* tab, char cel)
{
  char ** res;
  unsigned long i=0, j, pos, k,z,w;
	
  for (i=0,pos=1;tab[i]!=(char)0;i++)
    if (tab[i]==cel)
      pos++;
  i=0;
	
  res =(char**) malloc((pos+1) * sizeof(char *));
	
  res [pos] = NULL;
	
  for (k=0,i=0;k<pos;k++)
  {
    for (j=i;tab[j]!=cel&&tab[j]!=(char)0;j++) /*debugdot("tab[%d]=%c",j,tab[j])*/;
	
    res [k] = (char*) malloc((j-i+1) * sizeof(char));
	
    res [k] [j-i] = (char)0;
	
   /* w=i;
    for(z=0;z!=j-i;++z){
		res[k][z]=tab[w];
		w++;
	}*/
	    memcpy (res [k], tab+i, (j-i) * sizeof(char));
 
    i=j+1;
  }
  return res;
}

bool dotemuBmpFont::ParseFont(  Common::SeekableReadStream* stream)
{
	
	int i=1;
	//debugdot("parseFont");
	while( !stream->eos() )
	{
		char* _str = (char*)malloc(1024*sizeof(char));
		stream->readLine(_str, 1024);
		//const char* _str=(stream->readLine()).nc_str();
		//debugdot("str = %s", _str);
		char** splitStr=Split(_str,' ');
		//read the line's type
		//debugdot("splitStr 0 = %s",splitStr[0]);
		if( strcmp(splitStr[0] ,"common") ==0)
		{
			//debugdot("COMMMMMOOOOONN!!!!!!!!!");
			//this holds common data
			while( splitStr[i]!=(char)0)
			{
				
				char** splitKeyValue=Split(splitStr[i],'=');
				i++;
				//assign the correct value
				//debugdot(" SplitKeyValue %s , %s",splitKeyValue[0],splitKeyValue[1]);
				if( strcmp(splitKeyValue[0] , "lineHeight")==0 )
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.LineHeight);
				else if( strcmp(splitKeyValue[0] , "base") ==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Base);
				else if( strcmp(splitKeyValue[0] , "scaleW")==0 )
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Width);
				else if( strcmp(splitKeyValue[0] , "scaleH")==0 )
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Height);
				else if( strcmp(splitKeyValue[0] , "pages")==0 )
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Pages);
			}
			i=1;
		}
		else if( strcmp(splitStr[0] , "char" )==0)
		{
			//debugdot("CHARRRRRR!!!!!!!!");
			//this is data for a specific char
			unsigned short CharID = 0;

			while( splitStr[i]!=(char)0 )
			{
				char** splitKeyValue=Split(splitStr[i],'=');
				i++;
				//assign the correct value
				//debugdot(" SplitKeyValue %s , %s",splitKeyValue[0],splitKeyValue[1]);
				if( strcmp(splitKeyValue[0] , "id")==0 )
					sscanf(splitKeyValue[1], "%ld",&CharID);
				else if( strcmp(splitKeyValue[0] , "x" )==0)
					
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID]);
				else if( strcmp(splitKeyValue[0] , "y" )==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].y);
				else if( strcmp(splitKeyValue[0] , "width" )==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].Width);
				else if( strcmp(splitKeyValue[0] , "height") ==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].Height);
				else if( strcmp(splitKeyValue[0] , "xoffset" )==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].XOffset);
				else if(strcmp( splitKeyValue[0] , "yoffset" )==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].YOffset);					
				else if( strcmp(splitKeyValue[0] , "xadvance" )==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].XAdvance);					
				else if( strcmp(splitKeyValue[0],"page" )==0)
					sscanf(splitKeyValue[1], "%ld",&CharsetDesc.Chars[CharID].Page);
					
			}
			i=1;
		}
	}

	return true;
}

void dotemuBmpFont::loadBmp(Common::SeekableReadStream* stream){
	if(!_png.loadStream(*stream))
		debugdot("echec de la lecture du fichier de bmpFont");
	else {
		_bmpSurface=*_png.getSurface();			
	}
	

}

