package com.dotemu.gobliiins;

import android.content.Context;

import com.dotemu.gobliiins.GameInstaller;
import com.dotemu.gobliiins.GameInstallerProgressListener;
import com.dotemu.gobliiins.R;

public final class GobliiinsInstaller extends GameInstaller {

	public final static String PACKAGE_MAIN_NAME = "com.dotemu.gobliiins";
	public final static String PACKAGE_MAIN_FILE = "Gobliiins_Trilogy.zip";//"main.2.com.dotemu.gobliiins.zip";
	public final static int PACKAGE_MAIN_SIZE = 326676480;

	public GobliiinsInstaller(Context context, GameInstallerProgressListener listener) {
		super(context, listener);
	}

	@Override
	public boolean unpackCurrentPackage() {
		if (currentPackage.getUrl().equals("STAND_ALONE")) {
			if (currentPackage.getFile().equals(PACKAGE_MAIN_FILE)) {
				standAloneIs = context.getResources().openRawResource(R.raw.gobliiins);
			}
		}

		return super.unpackCurrentPackage();
	}

}
